set datafile separator ","
set term post eps enhanced color size 5,2 font "Times-Roman, 20"

set linestyle 1 lw 3 lt 1 lc rgb "blue"
set linestyle 2 lw 3 lt 1 lc rgb "red"

set xtics offset 0,0.3
set xtics 0.008,0.008,0.05
set ytics offset 0.5,0
set y2tics

##
set output 'NAND_in_VI.eps'

set xrange[0.0026:0.0062]
set yrange[0:22]
set y2range[0:3]
set key right below
set xlabel "{/Times-Italic t}" offset 0,0.8
set ylabel "{/Times-Italic V_{/Times-Roman in}}" offset 0.55,0
set y2label "{/Times-Italic I_{/Times-Roman in}}" offset 0.55,0
plot "NAND_experiment.csv" using 1:4 axis x1y2 with steps ls 2 title "current",\
     "NAND_experiment.csv" using 1:2 with steps ls 1 title "voltage"

##
set output 'NAND_in_P.eps'

set xrange[0.0026:0.0062]
set yrange[0:60]
set key right below
set xlabel "{/Times-Italic t}" offset 0,0.8
set ylabel "{/Times-Italic P_{/Times-Roman in}}" offset 0.55,0
plot "NAND_experiment.csv" using 1:($2*$4) with steps ls 2 title "power"

##
set output 'NAND_out_VI.eps'

set xrange[0.0026:0.0062]
set yrange[0:22]
set y2range[0:3]
set key right below
set xlabel "{/Times-Italic t}" offset 0,0.8
set ylabel "{/Times-Italic V_{/Times-Roman out}}" offset 0.55,0
set y2label "{/Times-Italic I_{/Times-Roman out}}" offset 0.55,0
plot "NAND_experiment.csv" using 1:5 axis x1y2 with steps ls 2 title "current",\
     "NAND_experiment.csv" using 1:3 with steps ls 1 title "voltage"

##
set output 'NAND_out_P.eps'

set xrange[0.0026:0.0062]
set yrange[0:60]
set key right below
set xlabel "{/Times-Italic t}" offset 0,0.8
set ylabel "{/Times-Italic P_{/Times-Roman out}}" offset 0.55,0
plot "NAND_experiment.csv" using 1:($3*$5) with steps ls 2 title "power"
