clear

%% Set parameters
run("./state_eq.m")

%% Execute simulations for all sorts of logic operation
for logic=1:6 % logic=1,2,3... => AND,OR,NAND,NOR,EXOR,EXNOR
    sample=0.004;
    capacitor=16.9;
    
    sim('multi_operation');
    w_out.signals.values=w_out.signals.values(2:5,1);%pick up 4 plots
    w_in.signals.values=w_in.signals.values(2:9,1);%pick up 8 plots
    w_out_fb.signals.values=w_out_fb.signals.values(2:9,1);%pick up 8 plots for timeslot f&b
    
    
    if logic==1
        n=size(w_out.signals.values);%initialize
        w_out_values=zeros(n(1,1),6);
        
        n1=size(w_in.signals.values);
        w_in_values=zeros(n1(1,1),6);
        
        n2=size(w_out_fb.signals.values);
        w_out_fb_values=zeros(n2(1,1),6);
        
        
        n0=size(con_v.signals.values);
        con_v_values=zeros(n0(1,1),6);
        power_in_values=zeros(n0(1,1),6);
        power_out_values=zeros(n0(1,1),6);
        v_in_values=zeros(n0(1,1),6);
        v_out_values=zeros(n0(1,1),6);
        
        w_out_values(:,logic)=w_out.signals.values;
        w_in_values(:,logic)=w_in.signals.values;
        w_out_fb_values(:,logic)=w_out_fb.signals.values;
        con_v_values(:,logic)=con_v.signals.values;
        con_v_time=con_v.time;
        power_in_values(:,logic)=power_in.signals.values;
        power_out_values(:,logic)=power_out.signals.values;
        v_in_values(:,logic)=v_in.signals.values;
        v_out_values(:,logic)=v_out.signals.values;
        
    else
        w_out_values(:,logic)=w_out.signals.values;
        w_in_values(:,logic)=w_in.signals.values;
        w_out_fb_values(:,logic)=w_out_fb.signals.values;
        con_v_values(:,logic)=con_v.signals.values;
        power_in_values(:,logic)=power_in.signals.values;
        power_out_values(:,logic)=power_out.signals.values;
        v_in_values(:,logic)=v_in.signals.values;
        v_out_values(:,logic)=v_out.signals.values;
        
    end
end

%% w_out
Max1=max([w_in_values [w_out_values;zeros(4,6)]]);
Max2=max(Max1); %find out the max value
w_out_values= w_out_values/Max2; %normalization
w_out_values= w_out_values'; %translocation

add_ver=zeros(6,1); %for pcolor
add_hor=zeros(1,5); %for pcolor
w_out_values=[w_out_values add_ver;add_hor];%for pcolor

w_out_values(w_out_values<=1e-1)=0;%
w_out_min_place=find(w_out_values>0);%find the place of "NOT 0"
w_out_min=min(w_out_values(w_out_min_place));%find the minimum value

%  map_ver=0:1e-5:1;%color from min to max
%  map=[ones(1,3);zeros(size(map_ver,2),2) map_ver'];%color mapping
colormap default;
clearvars gray;
color=sort(autumn,'descend');

map2=[ones(1,3);color];

w_out_fig=pcolor(w_out_values);
%  colorbar;
colormap(map2)
caxis([w_out_min-7e-2 1]);%1.06
xticklabels({})
yticklabels({})
w_out_fig.LineWidth = 1.5;
set(gcf,'Position','default');
saveas(w_out_fig,'w_out_fig','epsc');

%% w_in
w_in_values= w_in_values/Max2; %normalization
w_in_values= w_in_values'; %translocation

add_in_ver=zeros(6,1); %for pcolor
add_in_hor=zeros(1,9); %for pcolor 8+1
w_in_values=[w_in_values add_in_ver;add_in_hor];%for pcolor

w_in_values(w_in_values<=1e-2)=0;%
w_in_min_place=find(w_in_values>0);%find the place of "NOT 0"
w_in_min=min(w_in_values(w_in_min_place));%find the minimum value

colormap default;
clearvars gray;
color=sort(autumn,'descend');

map2=[ones(1,3);color];

w_in_fig=pcolor(w_in_values);
colorbar;
colormap(map2)
caxis([w_in_min-7e-2 1]);%1.06
xticklabels({})
yticklabels({})
w_in_fig.LineWidth = 1.5;
set(gcf,'Position','default');
saveas(w_in_fig,'w_in_fig','epsc');

%% w_out_fb
w_out_fb_values= w_out_fb_values/Max2; %normalization
w_out_fb_values= w_out_fb_values'; %translocation

add_out_fb_ver=zeros(6,1); %for pcolor
add_out_fb_hor=zeros(1,9); %for pcolor 8+1
w_out_fb_values=[w_out_fb_values add_out_fb_ver;add_out_fb_hor];%for pcolor

w_out_fb_values(w_out_fb_values<=1e-2)=0;%
w_out_fb_min_place=find(w_out_fb_values>0);%find the place of "NOT 0"
w_out_fb_min=min(w_out_fb_values(w_out_fb_min_place));%find the minimum value

%  map_ver=0:1e-5:1;%color from min to max
%  map=[ones(1,3);zeros(size(map_ver,2),2) map_ver'];%color mapping
colormap default;
clearvars gray;
color=sort(autumn,'descend');

map2=[ones(1,3);color];

w_out_fb_fig=pcolor(w_out_fb_values);
%  colorbar;
colormap(map2)
caxis([w_out_fb_min-7e-2 1]);%1.06
xticklabels({})
yticklabels({})
w_out_fb_fig.LineWidth = 1.5;
set(gcf,'Position','default');
saveas(w_out_fb_fig,'w_out_fb_fig','epsc');


%% con_v
for logic=1:6
    x=con_v_time;
    y=con_v_values(:,logic);
    figure(logic);
    con_v_fig=plot(x,y,'k','LineWidth',2);
    xlim([0 t98*8]);
    ylim([16.75 17]);
    xticks(0:t98:t98*8);
    
    
    width  = 1023;
    height = 341;
    pos(3)=width;
    pos(4)=height;
    set(gcf,'Position',pos);
    set(gcf,'defaultAxesFontSize',20);
    font='TimesRoman';
    set(gcf,'defaultAxesFontName',font);
    set(gca,'LineWidth',1.5);
    
    if logic==1
        saveas(con_v_fig,'con_v_AND','epsc');
    elseif logic==2
        saveas(con_v_fig,'con_v_OR','epsc');
    elseif logic==3
        saveas(con_v_fig,'con_v_NAND','epsc');
    elseif logic==4
        saveas(con_v_fig,'con_v_NOR','epsc');
    elseif logic==5
        saveas(con_v_fig,'con_v_EXOR','epsc');
    elseif logic==6
        saveas(con_v_fig,'con_v_EXNOR','epsc');
    end
    
end

%% power_in
for logic=1:6
    x=con_v_time;
    y=power_in_values(:,logic);
    figure(logic);
    
    power_in_fig=plot(x,y,'k','LineWidth',2);
    xlim([1.5*tb t98*8.03]);
    ylim([0 50]);
    yticks(0:10:50);
    xticks(0:t98:t98*8);
    
    width  = 1023;
    height = 341;
    pos(3)=width;
    pos(4)=height;
    set(gcf,'Position',pos);
    set(gcf,'defaultAxesFontSize',20);
    font='TimesRoman';
    set(gcf,'defaultAxesFontName',font);
    set(gca,'LineWidth',1.5);
    
    if logic==1
        saveas(power_in_fig,'power_in_AND','epsc');
    elseif logic==2
        saveas(power_in_fig,'power_in_OR','epsc');
    elseif logic==3
        saveas(power_in_fig,'power_in_NAND','epsc');
    elseif logic==4
        saveas(power_in_fig,'power_in_NOR','epsc');
    elseif logic==5
        saveas(power_in_fig,'power_in_EXOR','epsc');
    elseif logic==6
        saveas(power_in_fig,'power_in_EXNOR','epsc');
    end
    
end

%% power_out
for logic=1:6
    x=con_v_time;
    y=power_out_values(:,logic);
    figure(logic);
    
    power_out_fig=plot(x,y,'k','LineWidth',2);
    xlim([1.5*tb t98*8.03]);
    ylim([0 50]);
    yticks(0:10:50);
    xticks(0:t98:t98*8);
    
    width  = 1023;
    height = 341;
    pos(3)=width;
    pos(4)=height;
    set(gcf,'Position',pos);
    set(gcf,'defaultAxesFontSize',20);
    font='TimesRoman';
    set(gcf,'defaultAxesFontName',font);
    set(gca,'LineWidth',1.5);
    
    if logic==1
        saveas(power_out_fig,'power_out_AND','epsc');
    elseif logic==2
        saveas(power_out_fig,'power_out_OR','epsc');
    elseif logic==3
        saveas(power_out_fig,'power_out_NAND','epsc');
    elseif logic==4
        saveas(power_out_fig,'power_out_NOR','epsc');
    elseif logic==5
        saveas(power_out_fig,'power_out_EXOR','epsc');
    elseif logic==6
        saveas(power_out_fig,'power_out_EXNOR','epsc');
    end
    
end

%% v_in
for logic=1:6
    x=con_v_time;
    y=v_in_values(:,logic);
    figure(logic);
    
    v_in_fig=plot(x,y,'k','LineWidth',2);
    xlim([1.5*tb t98*8.03]);
    ylim([0 20]);
    yticks(0:5:20);
    xticks(0:t98:t98*8);
    
    width  = 1023;
    height = 341;
    pos(3)=width;
    pos(4)=height;
    set(gcf,'Position',pos);
    set(gcf,'defaultAxesFontSize',20);
    font='TimesRoman';
    set(gcf,'defaultAxesFontName',font);
    set(gca,'LineWidth',1.5);
    
    if logic==1
        saveas(v_in_fig,'v_in_AND','epsc');
    elseif logic==2
        saveas(v_in_fig,'v_in_OR','epsc');
    elseif logic==3
        saveas(v_in_fig,'v_in_NAND','epsc');
    elseif logic==4
        saveas(v_in_fig,'v_in_NOR','epsc');
    elseif logic==5
        saveas(v_in_fig,'v_in_EXOR','epsc');
    elseif logic==6
        saveas(v_in_fig,'v_in_EXNOR','epsc');
    end
    
end

%% v_out
for logic=1:6
    x=con_v_time;
    y=v_out_values(:,logic);
    figure(logic);
    
    v_out_fig=plot(x,y,'k','LineWidth',2);
    xlim([1.5*tb t98*8.03]);
    ylim([0 20]);
    yticks(0:5:20);
    xticks(0:t98:t98*8);
    
    width  = 1023;
    height = 341;
    pos(3)=width;
    pos(4)=height;
    set(gcf,'Position',pos);
    set(gcf,'defaultAxesFontSize',20);
    font='TimesRoman';
    set(gcf,'defaultAxesFontName',font);
    set(gca,'LineWidth',1.5);
    
    if logic==1
        saveas(v_out_fig,'v_out_AND','epsc');
    elseif logic==2
        saveas(v_out_fig,'v_out_OR','epsc');
    elseif logic==3
        saveas(v_out_fig,'v_out_NAND','epsc');
    elseif logic==4
        saveas(v_out_fig,'v_out_NOR','epsc');
    elseif logic==5
        saveas(v_out_fig,'v_out_EXOR','epsc');
    elseif logic==6
        saveas(v_out_fig,'v_out_EXNOR','epsc');
    end
    
end
